///////////////////////////////////////////////////////////////////////
//                                                   41 Post                                       //
// Created by DimasTheDriver in 23/Feb/2010                                      //
// Part of 'Using C# Delegates in Unity3D scripts' post.                      //
// Availiable at:      http://www.41post.com/?p=3146                             //
/////////////////////////////////////////////////////////////////////

using UnityEngine;
using System.Collections;

public class EnemyActions : MonoBehaviour 
{
	//a variable to store this game object's Transform
	private Transform myTransform;
	
	void Awake()
	{
		//get the game object the script is attached to
		myTransform = this.GetComponent<Transform>();
	}
	
	//this method makes the enemy follow the player
	public void FollowPlayer(Transform playerTransform)
	{
		//look at the player
		myTransform.LookAt(playerTransform);

		//only follow the player if this enemy is 4.5 units away from the player
		if(Vector3.Distance(myTransform.position,playerTransform.position)>=4.5f)
		{
			//move the enemy
			myTransform.Translate(Vector3.forward * Time.deltaTime* 0.5f);
		}
	}
	
	//this method makes the enemy fly
	public void Fly(Transform pTransform)
	{
		//if the player is at 4.5f units away
		if(Vector3.Distance(myTransform.position,pTransform.position)<=4.5f)
		{
			//make it fly
			myTransform.Translate(Vector3.up * Time.deltaTime);
		}
		else
		{
			//make it land
			if(myTransform.position.y >= 0.525528f)
			{
				myTransform.Translate(-Vector3.up * Time.deltaTime);
			}
		}
	}
}
