///////////////////////////////////////////////////////////////////////
//                                                   41 Post                                       //
// Created by DimasTheDriver in 23/Feb/2010                                      //
// Part of 'Using C# Delegates in Unity3D scripts' post.                      //
// Availiable at:      http://www.41post.com/?p=3146                             //
/////////////////////////////////////////////////////////////////////

using UnityEngine;
using System.Collections;

public class ReactiveEnemy : MonoBehaviour 
{
	//a variable to store this game object's Transform
	private Transform myTransform;
	//a variable to store the player's character Transform
	private Transform playerTransform;
	//a static boolean variable  to tell if the player has collided with any trigger
	public static bool hasCollided = false;
	
	//Initialization code
	void Awake()
	{
		//get the game object the script is attached to
		myTransform = this.GetComponent<Transform>();
		//get the player's Transform
		playerTransform = GameObject.FindWithTag("Player").GetComponent<Transform>();
	}
	
	//runs every game cycle
	void Update()
	{
		//checks if the player has collided with any enemy trigger
		if(hasCollided)
		{
			//follow the player
			Follow();
		}
	}
	
	//this method makes the enemy follow the player
	private void Follow()
	{
		//look at the player
		myTransform.LookAt(playerTransform);
		
		//only follow the player if this enemy is 4.5 uniyts away from the player
		if(Vector3.Distance(myTransform.position,playerTransform.position)>=4.5f)
		{
			//move the enemy
			myTransform.Translate(Vector3.forward * Time.deltaTime* 0.5f);
		}
	}
}
